/*
 *      L I S T _ c o u n t
 *
 *  This function is called when it is required
 *  to get the count of nodes in a list.
 *
 *
 * (c) Copyright 1996 David J. Walker
 *     Email:  d.j.walker@slh0101.wins.icl.co.uk
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  12 May 96   DJW   - First version
 */

#include <liblist.h>
#include <sys/liblist.h>


int     list_count (list_t list)
{
    register int     count;
    register node_t  node;
    register _listmaster_t  master;

    debug ("LIST_Count", \
           "list parameter is not a valid list instance", \
           _LIST_ListType(list));

    for (count = 0, node = LIST_First(list), master=list->class->master ; 
            node != NULL ; 
                node = (*master->next)(list,_LIST_REALNODE(list,node)))
    {
        count++;
    }
    return (count);
}

