/*
 *          _ L I S T _ F i f o A f t e r
 *
 *  This routine adds a node on a list that
 *  DOES maintain a pointer to the last node
 *
 *
 * (c) Copyright 1996 David J. Walker
 *     Email:  d.j.walker@slh0101.wins.icl.co.uk
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  23 May 96   DJW   - First version
 *
 *  28 May 96   DJW   - Updated 'remove' to allow for the user providing
 *                      a memver to remove who is not on the list!
 */


#include <liblist.h>
#include <sys/liblist.h>
#include <errno.h>


int     _LIST_FifoAfter (list_t list, node_t newnode, node_t oldnode)

#define _list  ((_fifoh_t)list)
{
    int     reply;

    reply = _LIST_LifoAfter(list, newnode, oldnode);
    if (_list->last == NULL  || _list->last == oldnode)
    {
        _list->last = newnode;
    }
    return (reply);
}
#undef _list

