/*
 *      _ L I S T _ F i f o L a s t
 *
 *  This is a support function.   It is used to
 *  find the last function for a linked list type 
 *  that DOES maintain a pointer to the last 
 *  node (such as out implementation of a FIFO).
 *
 *
 * (c) Copyright 1996 David J. Walker
 *     Email:  d.j.walker@slh0101.wins.icl.co.uk
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  18 May 96   DJW   - First version
 */


#include <liblist.h>
#include <sys/liblist.h>


extern
node_t  _LIST_FifoLast      (list_t list)
{
    register node_t  node;

    node = ((_fifoh_t)list)->last;
    /*
     *  If the list is empty, we
     *  must return a NULL value.
     */
    if (node != NULL)
    {
        node = _LIST_USERNODE(list,node);
    }
    return node;
}

