/*
 *      L I S T _ F r e e N o d e
 *
 *  This function is called when it is required
 *  to destroy a node.
 *
 *
 * (c) Copyright 1996 David J. Walker
 *     Email:  d.j.walker@slh0101.wins.icl.co.uk
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  18 May 96   DJW   - First version
 */

#include <liblist.h>
#include <sys/liblist.h>
#include <stdlib.h>


int     LIST_FreeNode  (list_t list,  node_t node)
{

    debug ("LIST_FreeNode", \
            "'list' parameter is not a valid list pointer", \
            _LIST_ListType(list));
    debug ("LIST_FreeNode", \
            "'node' paramter is not a valid member of this list type",\
            _LIST_ListId(list,node));
    debug ("LIST_FreeNode", \
            "'node is still a member of this list", \
             LIST_Index(list,node) == 0);


    if (list->class->killnode != NULL)
    {
        int reply;

        reply = (*list->class->killnode)(node);
        if (reply != 0)
        {
            return (reply);
        }
    }
    free (_LIST_REALNODE(list,node));
    return (0);
}

