/*
 *      h a s h _ c
 *
 *  This contains routines that are specific
 *  to the implementation of hash tables
 *
 *
 * (c) Copyright 1996 David J. Walker
 *     Email:  d.j.walker@slh0101.wins.icl.co.uk
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  12 May 96   DJW   - First version
 */

#include <liblist.h>
#include <sys/liblist.h>
#include <errno.h>

/*=======================================================================
 *
 *      The following structure is used for by the default
 *      hash table routines supplied with this library
 *----------------------------------------------------------------------*/

struct mynode {
        char *  name;
        };
typedef struct mynode * MYNODE_t;


/*============================================================ HASH_CLONE */
static
int     HASH_Clone  (list_t list)
/*      ~~~~~~~~~~
 *------------------------------------------------------------------------*/
{
    (void)list;
    return EINVAL;
}


/*========================================================== HASH_NEWNODE */
static
int     HASH_NodeNew  (list_t list, node_t node, va_list ap)
/*      ~~~~~~~~~~~~
 *------------------------------------------------------------------------*/
{
    (void)list;
    (void)node;
    (void)ap;
    return EINVAL;
}


/*========================================================= HASH_NODEINIT */
static
int     HASH_NodeInit (node_t node, va_list ap)
/*      ~~~~~~~~~~~~~
 *------------------------------------------------------------------------*/
{
    (void)node;
    (void)ap;
    return 0;
}


/*========================================================= HASH_NODEKILL */
static
int     HASH_NodeKill (node_t node)
/*      ~~~~~~~~~~~~~
 *------------------------------------------------------------------------*/
{
    (void)node;
    return 0;
}


/*========================================================= HASH_NODECOMP */
static
int     HASH_NodeComp (node_t node1, node_t node2)
/*      ~~~~~~~~~~~~~
 *------------------------------------------------------------------------*/
{
    (void)node1;
    (void)node2;
    return 0;
}


#if 0
/*============================================================= HASH_CALC */
static
size_t  hashcalc (MYNODE_t node)
/*      ~~~~~~~~
 *  This is the default hash table routine used if the user supplies
 *  no alternative  (it is the same as used in the C68 compiler).
 *------------------------------------------------------------------------*/
{
    register size_t sum;
    register char * name;

    for (sum =0; *name; )
    {
        sum += (sum << 5) + (size_t)*name++;
    }
    return (sum);
}
#endif


/*========================================================================
 *
 *  This is the list of vectored functions
 *  that are used to support this list type.
 *
 *------------------------------------------------------------------------*/

static struct _listmaster master =
        {
        sizeof(struct _btreeh),     /* Size of the list header */
        sizeof(struct _btree),      /* Size of the node header */
        &_LIST_ListCount,
        &_LIST_HashFirst,
        &_LIST_HashLast,
        &_LIST_HashNext,
        &_LIST_HashPrevious,
        &HASH_Clone,
        &HASH_NodeNew,
        &_LIST_HashAdd,
        &_LIST_HashAfter,
        &_LIST_HashRemove,
        &_LIST_HashFind,
        _LIST_HASH,
        "HASH",
        "Hash Table"
        };

/*
 *  This is the default settings for a new
 *  object of this type.
 */
struct _listclass _LISThash =
        {
        &master,                    /* Pointer to master class data */
        0,                          /* Clone count */
        0,                          /* Size of user node data */
        &HASH_NodeInit,             /* User node Initialise */
        &HASH_NodeKill,             /* User node Destroy */
        &HASH_NodeComp,             /* user node Compare */
        LIST_FIFO                   /* Linked list type */
        };


