
#ifndef _LIBLIST_H
#define _LIBLIST_H
#ifndef _SYS_TYPES_H
#include <sys/types.h>
#endif
#ifndef _STDDEF_H
#include <stddef.h>
#endif
#ifndef _STDARG_H
#include <stdarg.h>
#endif
#ifdef __STDC__
#define _P_(params) params
#else
#define _P_(params)
#endif
struct _listhead;
struct _listclass;
typedef struct _listhead * list_t;
typedef struct _listclass * listclass_t;
typedef void * node_t;
#define LIST_SINGLE &_LISTlist1
#define LIST_DOUBLE &_LISTlist2
#define LIST_QUEUE &_LISTfifo
#define LIST_FIFO &_LISTfifo
#define LIST_STACK &_LISTlifo
#define LIST_LIFO &_LISTlifo
#define LIST_BTREE &_LISTbtree
#define LIST_BALTREE &_LISTbaltree
#define LIST_HASH &_LISThash
extern struct _listclass _LISTlist1;
extern struct _listclass _LISTlist2;
extern struct _listclass _LISTfifo;
extern struct _listclass _LISTlifo;
extern struct _listclass _LISTbtree;
extern struct _listclass _LISTbaltree;
extern struct _listclass _LISThash;
int LIST_Count _P_((list_t));
int LIST_Ordered _P_((list_t));
#define LIST_UNORDERED 0
#define LIST_ORDERED 0x7fe1
#define LIST_ORDER_NA 0x7fe3
int LIST_Index _P_((list_t,node_t));
node_t LIST_First _P_((list_t));
node_t LIST_Last _P_((list_t));
node_t LIST_Next _P_((list_t,node_t));
node_t LIST_Previous _P_((list_t,node_t));
list_t LIST_Create _P_((listclass_t,size_t,\
int (*init)(node_t,va_list),\
int (*kill)(node_t),\
int (*compare)(node_t,node_t) ));
list_t LIST_Clone _P_((list_t));
int LIST_HashSetup _P_((list_t,size_t,\
size_t (*nodehash)(node_t),\
list_t linkedlist));
#define LIST_HASHONLY ((list_t)(1))
int LIST_Destroy _P_((list_t));
node_t LIST_NewNode _P_((list_t,...));
int LIST_FreeNode _P_((list_t,node_t));
int LIST_Add _P_((list_t,node_t));
node_t LIST_NewAdd _P_((list_t,...));
int LIST_Insert _P_((list_t,node_t));
node_t LIST_NewInsert _P_((list_t,...));
int LIST_Append _P_((list_t,node_t));
node_t LIST_NewAppend _P_((list_t,...));
int LIST_Before _P_((list_t,node_t,node_t));
node_t LIST_NewBefore _P_((list_t,node_t,...));
int LIST_After _P_((list_t,node_t,node_t));
node_t LIST_NewAfter _P_((list_t,node_t,...));
int LIST_Remove _P_((list_t,node_t));
int LIST_Delete _P_((list_t,node_t));
int LIST_Compare _P_((list_t,node_t,node_t));
long LIST_Enumerate _P_((list_t,int (*enumfunc)(node_t,va_list),...));
node_t LIST_Find _P_((list_t,int (*findfunc)(node_t,va_list),...));
node_t LIST_Position _P_((list_t,size_t));
int LIST_Enqueue _P_((list_t,node_t));
node_t LIST_NewEnqueue _P_((list_t,...));
node_t LIST_Dequeue _P_((list_t));
int LIST_Push _P_((list_t,node_t));
node_t LIST_NewPush _P_((list_t,...));
node_t LIST_Pop _P_((list_t));
node_t LIST_Peek _P_((list_t));
#undef _P_
#endif
