/*
 *      L I S T _ I n d e x
 *
 *  This function is called when it is required
 *  to find out the position of a node in the list.
 *
 *
 * (c) Copyright 1996 David J. Walker
 *     Email:  d.j.walker@slh0101.wins.icl.co.uk
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  18 May 96   DJW   - First version
 */

#include <liblist.h>
#include <sys/liblist.h>

int     LIST_Index (list_t list, node_t node)
{
    int     count;
    node_t  listnode;

    debug ("LIST_Index", \
           "'list' parameter is not a valid list instance", \
           _LIST_ListType(list));
    debug ("LIST_Index", \
           "'node' is not a valid member of this list type", \
           _LIST_ListId(list,node));

    for (count = 1, listnode = LIST_First(list) ; listnode != NULL; 
                        count++, listnode = LIST_Next(list,listnode))
    {
        /*
         *  If the addresses are the same,
         *  then the nodes must be!
         */
        if (listnode == node)
        {
            return (count);
        }
    }
    /*
     *  The node was not found if
     *  this point is reached.
     */
    return (0);
}

