/*
 *      L I S T _ I n s e r t 
 *
 *  This function is called when it is required
 *  to insert a new node at the beginning of a list.
 *
 *
 * (c) Copyright 1996 David J. Walker
 *     Email:  d.j.walker@slh0101.wins.icl.co.uk
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  22 May 96   DJW   - First version
 */

#define __LIBLIST__
#include <liblist.h>
#include <sys/liblist.h>

int     LIST_Insert (list_t list, node_t node)
{

    debug ("LIST_Insert", \
            "'list' parameter is not a valid list pointer", \
            _LIST_ListType(list));
    debug ("LIST_Insert", \
            "'node' paramter is not a valid member of this list type",\
            _LIST_ListId(list,node));
    debug ("LIST_Insert", \
            "'node is already a member of this list", \
             LIST_Index(list,node) == 0);

    return LIST_Before (list, _LIST_REALNODE(list,node), NULL);
}

