/*
 *      l i f o _ c
 *
 *  This contains routines that are specific to the
 *  implementation of LIFO lists (stacks)
 *
 *
 * (c) Copyright 1996 David J. Walker
 *     Email:  d.j.walker@slh0101.wins.icl.co.uk
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  12 May 96   DJW   - First version
 */

#include <liblist.h>
#include <sys/liblist.h>


/*========================================================================
 *
 *  This is the list of vectored functions
 *  that are used to support this list type.
 *
 *------------------------------------------------------------------------*/
static struct _listmaster master =
        {
        sizeof(struct _lifoh),      /* Size of the list header */
        sizeof(struct _lifo),       /* Size of the node header */
        &_LIST_ListCount,
        &_LIST_ListFirst,
        &_LIST_LifoLast,
        &_LIST_ListNext,
        &_LIST_LifoPrevious,
        NULL,
        NULL,
        &_LIST_ListAdd,
        &_LIST_LifoAfter,
        &_LIST_LifoRemove,
        &_LIST_ListFind,
        _LIST_LIFO,
        "LIFO",
        "LIFO List (stack)"
        };

/*
 *  This is the default settings for a new
 *  object of this type.
 */
struct _listclass _LISTlifo =
        {
        &master,                    /* List of supported functions */
        0,                          /* Clone count */
        0,                          /* Size of node data */
        NULL,                       /* User node Initialise */
        NULL,                       /* User node Destroy */
        NULL,                       /* user node Compare */
        NULL                        /* Linked list (none) */
        };



