/*
 *      _ L I S T _ L i f o P r e v i o us
 *
 *
 *  This is a routine for finding the previous
 *  node in a single linked list.
 *
 *
 * (c) Copyright 1996 David J. Walker
 *     Email:  d.j.walker@slh0101.wins.icl.co.uk
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  23 May 96   DJW   - First version
 *
 *  28 May 96   DJW   - Updated 'remove' to allow for the user providing
 *                      a memver to remove who is not on the list!
 */


#include <liblist.h>
#include <sys/liblist.h>
#include <errno.h>



node_t  _LIST_LifoPrevious    (list_t list, node_t node)

#define _list  ((_list1h_t)list)
#define _node  ((_list1_t)node)
{
    _list1_t  listnode;

    /*
     *  If this is the first node in the
     *  list there cannot be a previous one.
     */
    if (list->nodes == _node)
    {
        return NULL;
    }
    /*
     *  Scan the list for a node whose 'next'
     *  pointer points to the current node.
     */
    for (listnode = list->nodes ; 
                listnode != NULL ; listnode = listnode->next)
    {
        if (listnode->next == _node)
        {
            break;
        }
    }
    assert (listnode != NULL);
    return _LIST_USERNODE(list,listnode);
}
#undef _list
#undef _node


