/*
 *      _ L I S T _ L i s t A d d
 *
 *  This is an internal support routine
 *  to insert a node at the correct point in
 *  an ordered list.   Before we get here we
 *  can assume that the list has already been
 *  checked to see if it is ordered.
 *
 *
 * (c) Copyright 1996 David J. Walker
 *     Email:  d.j.walker@slh0101.wins.icl.co.uk
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  18 May 96   DJW   - First version
 */


#include <liblist.h>
#include <sys/liblist.h>


extern
int     _LIST_ListAdd (list_t list, node_t newnode)
{
    _list1_t nextnode, prevnode;

    /*
     *  We need to scan the whole list in sequence
     */
    for (prevnode = NULL, nextnode = list->nodes ; nextnode != NULL ; 
                prevnode = nextnode, nextnode = nextnode->next)
    {
        /*
         *  If the next node would be too far,
         *  then we must insert after the previous
         *  node (if any) in the list.
         */
        if ((*(list->class->compare))(_LIST_USERNODE(list, newnode), 
                                      _LIST_USERNODE(list,nextnode)) < 0)
        {
            break;
        }
    }
    return ((*(list->class->master->after))(list,newnode,prevnode));
}

