/*
 *      _ L I S T _ L i s t C o u n t
 *
 *  This is a support function.   It is used to
 *  count any list that needs to be worked through
 *  serially to find the count.
 *
 *
 * (c) Copyright 1996 David J. Walker
 *     Email:  d.j.walker@slh0101.wins.icl.co.uk
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  18 May 96   DJW   - First version
 */


#include <liblist.h>
#include <sys/liblist.h>


extern
size_t   _LIST_ListCount     (list_t list)
{
    register node_t  node;
    int     count;

    for (count = 0, node = LIST_First(list) ; 
                    node != NULL ; 
                            node = LIST_Next(list,node))
    {
        count++;
    }
    return count;
}

