/*
 *      _ L I S T _ L i s t I d
 *
 *  This function is an internal support routine that
 *  is used in the debug version of the library to
 *  check that the node has the correct ID.
 *
 *  NOTE.   This check depends on all node types
 *          havingthe check field in the same position
 *          (i.e. as the first field).
 *
 * (c) Copyright 1996 David J. Walker
 *     Email:  d.j.walker@slh0101.wins.icl.co.uk
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  25 May 96   DJW   - First version
 */


#include <liblist.h>
#include <sys/liblist.h>

extern
int    _LIST_ListId     (list_t list, node_t node)
{
#ifdef DEBUG
    _nodecheck_t realnode;

    if (node == NULL)
    {
        return 0;
    }
    realnode = _LIST_REALNODE(list,node);
    return (list == realnode->list);
#else
    (void)list;     /* lets stop compiler warnings! */
    (void)node;
    return (1);
#endif
}


