/*
 *      _ L I S T _ L i s t T y p e
 *
 *  This function is an internal support routine that
 *  is used in the debug version of the library to
 *  check that the lsit parameter seems sensible.
 *
 *  NOTE.   This check depends on all node types
 *          havingthe check field in the same position
 *          (i.e. as the first field).
 *
 * (c) Copyright 1996 David J. Walker
 *     Email:  d.j.walker@slh0101.wins.icl.co.uk
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  25 May 96   DJW   - First version
 */


#include <liblist.h>
#include <sys/liblist.h>


extern
int    _LIST_ListType   (list_t list)
{
#ifdef DEBUG
    register _listclass_t class;
    register _listmaster_t master;

    if (list == NULL)
    {
        return 0;
    }

    if ((class = list->class) == NULL)
    {
        return 0;
    }

    if ((master = class->master) == NULL)
    {
        return 0;
    }

    if (class->sizeuser == 0)
    {
        return 0;
    }
    switch (master->typeid)
    {
        case _LIST_SINGLE:
        case _LIST_DOUBLE:
        case _LIST_FIFO:
        case _LIST_LIFO:
        case _LIST_BTREE:
        case _LIST_BALTREE:
        case _LIST_HASH:
                return master->typeid;
        default:
                return 0;
    }
#else
    (void)list;     /* lets stop compiler warnings! */
    return (1);
#endif
}


