/*
 *      L I S T _ O r d e r e d
 *
 *  This function is called when it is required
 *  to find out if a list is ordered.
 *
 *
 *  Returns:
 *      0       No
 *      <>0     Yes
 *
 *
 * (c) Copyright 1996 David J. Walker
 *     Email:  d.j.walker@slh0101.wins.icl.co.uk
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  18 May 96   DJW   - First version
 */


#include <liblist.h>
#include <sys/liblist.h>
#include <errno.h>

int     LIST_Ordered (list_t list)
{
    register _listclass_t class;

    debug ("LIST_Ordered", \
           "'list' parameter is not a valid list instance", \
           _LIST_ListType(list));

    class = list->class;

    if (class->master->typeid == _LIST_HASH)
    {
        return LIST_ORDER_NA;
    }
    return  (class->compare != NULL ? LIST_ORDERED : LIST_UNORDERED);
}

