/*
 *      L I S T _ P r e v i o u s
 *
 *  This function is called to obtain the
 *  LIST_Previous property of a list.
 *
 *
 * (c) Copyright 1996 David J. Walker
 *     Email:  d.j.walker@slh0101.wins.icl.co.uk
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  22 May 96   DJW   - First version
 */

#include <liblist.h>
#include <sys/liblist.h>

node_t  LIST_Previous   (list_t list,  node_t node)
{
    debug ("LIST_Previous", \
           "'list' parameter is not a valid list instance", \
           _LIST_ListType(list));
    debug ("LIST_Previous", \
           "node is not a valid member of list", \
           _LIST_ListId(list,node));

    return (*list->class->master->previous)(list,_LIST_REALNODE(list,node));
}


