/*
 *      L I S T _ R e m o v e
 *
 *  This function is called when it is required
 *  to remove a node.
 *
 *
 * (c) Copyright 1996 David J. Walker
 *     Email:  d.j.walker@slh0101.wins.icl.co.uk
 *
 *     Permission to copy and/or distribute granted under the
 *     following conditions:
 *
 *     1). This notice must remain intact.
 *     2). The author is not responsible for the consequences of use
 *         this software, no matter how awful, even if they
 *         arise from defects in it.
 *     3). Altered version must not be represented as being the
 *         original software.
 *
 *
 *  AMENDMENT HISTORY
 *  ~~~~~~~~~~~~~~~~~
 *  24 May 96   DJW   - First version
 */

#include <liblist.h>
#include <sys/liblist.h>
#include <errno.h>

int     LIST_Remove (list_t list, node_t node)
{

    debug ("LIST_Remove", \
           "'list' parameter is not a valid list instance", \
           _LIST_ListType(list));
    debug ("LIST_Remove", \
           "'node' parameter is incorrect type for this list", \
           _LIST_ListId(list,node));
    debug ("LIST_Remove", \
           "'node' parameter is not a member of this list", \
            LIST_Index(list,node) != 0);

    return ((*(list->class->master->remove))(list,_LIST_REALNODE(list,node)));
}

